; 

    .486                                ; create 32 bit code
    .model flat, stdcall                ; 32 bit memory model
    option casemap :none                ; case sensitive
  
    include \masm32\include\windows.inc
    include \masm32\include\masm32.inc
    include \masm32\include\user32.inc
    include \masm32\include\kernel32.inc

    includelib \masm32\lib\masm32.lib
    includelib \masm32\lib\user32.lib
    includelib \masm32\lib\kernel32.lib

    .data?


    .data

; Copy this
; 
; Conversion from ASCII string to HEXadecimal value DWORD sized
; input - pointer to string
; returned number - in eax
; error checking: none, the programmer must be sure, what passed string is the number, not
; "random" bytes, or zero-length string
;
; Special notes:
; If your version of the ml.exe don't support 16-byte alignment, comment "align 16" lines.
;
; This proc demonstrate the unusually hex-to-dword conversion algo, and, it work fast... very fast
; On my machine, 100,000,000 (100 millions) times of conversion take ~4070 milliseconds,
; and, the same value ^^^ of conversion times in hex2dw proc take ~7550 milliseconds.
; Size of Axhex2dw - 44 bytes, size of hex2dw - 79 bytes.
; Code of Axhex2dw may be smallest, but this will be harmful to performance.
; And, I can test it only on CPU > P6 family, and on tested CPUs - this variant
; the same fastest. Reports about another CPUs timings greetings.
;
;	Copyright (c) Antariy
;
    .code _TEXT

option prologue:none
option epilogue:none

align 16
Axhex2dw    proc STDCALL lpszStr:DWORD
    push edi
    mov edi,[esp+8]
    xor ecx,ecx
    @@:
    movzx edx,byte ptr [edi]
    cmp edx,0	
    jz @done
    test dl,1000000Y
    setne cl
    add edx,ecx
    shl eax,4h
    add edi,1
    lea edx,[edx-30h+ecx*8]
    and edx,0fh
    add eax,edx
    jmp @B

    @done:
    pop edi
    ret 4
    
Axhex2dw    endp
option prologue:PrologueDef
option epilogue:EpilogueDef
; 
; End of Copying


; 
; The testing prog
    .data

align 16
str1    db  "ABCDEF01",0

.code _TEXT
align 16
start proc uses ebx

invoke GetCurrentProcess
invoke SetPriorityClass,eax,REALTIME_PRIORITY_CLASS
invoke Sleep,0

add esp,-1024
invoke Axhex2dw,offset str1
mov ecx,esp
push eax
call @F
db	"%08lX",0
@@:
push ecx
call wsprintf

lea edx,[esp+12]
push MB_ICONINFORMATION
call @F
db	"Converted value",0
@@:
push edx
push 0
call MessageBox

mov ebx,10000000
invoke GetTickCount
neg eax
push eax
@@:
REPEAT 10
invoke Axhex2dw,offset str1
ENDM
dec ebx
jnz @B
invoke GetTickCount
lea edx,[esp+4]
add [esp],eax
call @F
    db  "Axhex2dw Time %d ms",0
@@:
push edx
call wsprintf

lea ecx,[esp+12]    ; because we don't restore stack after wsprintf
push MB_ICONINFORMATION
call @F
db  "Timings",0
@@:
push ecx
push 0
call MessageBox

invoke Sleep,1000

mov ebx,10000000
invoke GetTickCount
neg eax
push eax
@@:
REPEAT 10
invoke htodw,offset str1
ENDM
dec ebx
jnz @B
invoke GetTickCount
lea edx,[esp+4]
add [esp],eax
call @F
    db  "hex2dw Time %d ms",0
@@:
push edx
call wsprintf

lea ecx,[esp+12]    ; because we don't restore stack after 2 times of wsprintf
push MB_ICONINFORMATION
call @F
db  "Timings",0
@@:
push ecx
push 0
call MessageBox

add esp,1024+12+12+12




@done:
 ret

start endp

end start
